package ch.usi.inf.sape.tracer.analyzer;

public class InfectoMeterVisualizer {

	private final String[] sourceFileNames;
	
	public InfectoMeterVisualizer(String[] sourceFileNames) {
		this.sourceFileNames = sourceFileNames;
	}


	public final static String Header = 
					"<head>"
					+ "<title>InfectoMeter</title>"
					+ "<meta charset=\"utf-8\">"
					+ "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">"
					+ "<link rel=\"stylesheet\" href=\"css/bootstrap.min.css\"> "
					+ "<script src=\"jquery-1.12.2.min.js\"></script>"
					+ "<script src=\"js/bootstrap.min.js\"></script>" 
					+ "<script src=\"lib/codemirror.js\"></script>"
					+ "<link rel=\"stylesheet\" href=\"lib/codemirror.css\">"
					+ "<link rel=\"stylesheet\" href=\"infecto.css\">"
					+ "<script src=\"mode/javascript/javascript.js\"></script>"
					+ "<script src=\"addon/selection/active-line.js\"></script>"
					+ "<script src=\"addon/edit/matchbrackets.js\"></script>"
					+ "</head>";

		
	public String buildTabsHeaders(){
		StringBuffer sb = new StringBuffer();
		sb.append("<ul class=\"nav nav-tabs\">");
		for (String source : sourceFileNames) {
			sb.append("<li class=\"active\"><a data-toggle=\"tab\" href=\"#"+source.replace('.', '_')+"\">")
				.append(source)
			.append("</a></li>");
		}
		  sb.append("</ul>");
		return sb.toString();
	}
	
	public String buildTabContents(){
		StringBuilder sb = new StringBuilder();
		sb.append("<div class=\"tab-content\">");
		for (String source : sourceFileNames) {
			sb.append("<div id=\"").append(source.replace('.', '_')).append("\" class=\"tab-pane fade in active\">");
			sb.append("<h3>").append(source).append("</h3>");
		}
		return sb.toString();
	}
}
