package ch.usi.inf.sape.tracer.analyzer.cdg;

import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.util.Printer;

public class ASMInstruction implements InstructionI{

	private final AbstractInsnNode insn;
	
	public ASMInstruction(AbstractInsnNode insn) {
		this.insn = insn;
	}

	@Override
	public String getName() {
		int opCode = insn.getOpcode();
		return opCode == -1 ? "NOP" : Printer.OPCODES[opCode];
	}

	@Override
	public AbstractInsnNode getNativeInstructionObject() {
		return insn;
	}

}
