package ch.usi.inf.sape.tracer.test.snippets;

import java.util.LinkedList;

/**
 * This class contains static methods to be invoked
 * by test methods of junit. The logic of each method
 * provides a sample scenario to apply the considered
 * tests on that. In the case of this class, the tests
 * target backward slicing.
 * 
 * @author reza
 *
 */
public class SlicingSnippetCollection {

	public static int flowThroughConditionalStmt(){
		int criterion = 4;
		int temp = 5;
		boolean cond = true;
		int newValue = 5;
		if (cond){
			criterion = newValue;
		}
		criterion = criterion + temp;
		return criterion;
	}
	
	public static int flowOffConditionalStmtTest1(){
		int criterion = 4;
		int temp = 5;
		boolean cond = false;
		if (!cond){
			int newValue = 5;
			if (cond){
				criterion = newValue;
			}
			criterion = criterion + temp;
		}
		return criterion;
	}
	
	public static void longExecutionTest1(){
		double[] data = {5,2,4,9,0,1,8,6};
		data[0] = 3;
		data[0] = 5;
		data[1] = 2;
		data[2] = 4;
		data[3] = 9;
		data[4] = 0;
		data[5] = 1;
		data[6] = 8;
		data[7] = 6;
		//don't remove this line
		double[] rev = bubbleRevSort(data);
		double[] sorted = insertionSort(rev);
		double criterion = binarySearch(sorted, 5, 0, 7);
	}
	//don't remvoe this line
	private static double[] bubbleRevSort(double[] data){
		int n = data.length;
		boolean swapped = false;
		do{
			swapped = false;
			for (int i = 1; i<n; i++){
				double dummy1 = data[i];		//criterion + 9
				if (data[i-1] < data[i]){
					double dummy2 = dummy1;		//criterion + 11
					double temp = data[i-1];
					data[i-1] = data[i];
					data[i] = temp; 
					temp = dummy2;				//criterion + 15
					swapped = true;
				}
			}

		}while (swapped);
		return data; 
	}
	//don't remove this line
	private static double[] insertionSort(double[] data){
		for (int i = 1; i < data.length; i++){
			int j = i;
			while (j > 0 && data[j-1] > data[j]){
				double temp = data[j];
				double dummy = temp;		//criterion + 29 
				data[j] = data[j-1];
				data[j-1] = temp;
				if (dummy > 4)				//criterion + 32
					dummy = 8;				//criterion + 33
				j--;
			}
		}
		return data;
	}
	//don't remove this line
	private static double binarySearch(double[] data, double key, int imin, int imax){
		if (imax < imin)
			throw new IllegalStateException();
		else
		{
			int imid = (imin + imax) / 2; 
			if (data[imid] > key)
				return binarySearch(data, key, imin, imid - 1);
			else if (data[imid] < key)
				return binarySearch(data, key, imid + 1, imax);
			else
				return imid;
		}
	}

	
	public static int flowDynamicLauncherTest1(boolean arg){
		int i = 5;
		double d = 90;
		int result = 2;
		if (d > i){
			if (arg)
				result = flowDynamicTest1(9);
			else
				result = flowDynamicTest1(12);
		}
		return result;
	}
	//don't remove this line
	public static int flowDynamicTest1(long arg){
		int criterion = 4;
		int temp = 5;
		if (arg > temp){
			int newValue = criterion;
			if (arg > 10){
				criterion = newValue + 1;
			}
			criterion = criterion + temp;
		}
		return criterion;
	}
	
	public static int flowDynamicLauncherTest2(boolean arg){
		int i = 5;
		double d = 90;
		int result = 2;
		if (d > i){
			if (arg)
				result = flowDynamicTest2(3);
			else
				result = flowDynamicTest2(12);
		}
		return result;
	}
	//don't remove this line
	public static int flowDynamicTest2(float arg){
		int criterion = 4;
		int temp = 5;
		if (arg < temp){
			int newValue = criterion;
			while (arg < criterion){
				criterion += newValue;
			}
			criterion = criterion + temp;
		}
		return criterion;
	}

	
	public static int pathTest(){
		int value = 0;
		Queue q = new Queue();
		q.add(Integer.valueOf(1));
		q.add(Integer.valueOf(2));
		q.add(Integer.valueOf(3));
		while(!q.isEmpty()){
			value = q.remove();
		}
		return value;
	}
	static class Queue{
		LinkedList<Integer> items = new LinkedList<>();
		int size = 0;
		public boolean isEmpty(){
			if (size == 0)
				return true;
			return false;
		}
		public void add(Integer n){
			items.add(n);
			size ++;
		}
		public Integer remove(){
			size--;
			return items.remove();
		}
	}

//	public static int chainOfInvocationsTest1(){
//		int flowThrough = flowThroughConditionalStmt();
//		int flowOff = flowOffConditionalStmtTest1();
//		
//	}

}
